import { EventEmitter } from "events";
import { Db, MongoError, ObjectID } from "mongodb";
import Logger from "@arealidea/logger";

export type DoneCallback = (error: MongoError) => void;

export interface MongoDbConfigInterface {
    readonly url: string;
    readonly name: string;
}

export default class DB extends EventEmitter {

    public constructor(config: MongoDbConfigInterface, logger: Logger);

    public cleanup(): void;

    /**
     * @async
     */
    public connect (): void;

    /**
     * @async
     * @param done
     */
    public close(done: DoneCallback);

    public get(): Db;

    public objectId(str: string): ObjectID;

    public reconnectLooper(): void;

}
